<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

/**
* Class which load required models, views, core files
*/
class Loader
{
    static private $coreClasses = array("ErrorHandler" => "",
                            "Controller" => "", 
                            "FrontController" => "",
                            "AutoComponent" => "",
                            "Object" => "",
                            "Session" => "",
                            "Request" => "",
                            "DataAggregator" => "",
                            "NameTool" => "",
                            "View" => "",
                            "Model" => "",
                            "ModelRecord" => "",
                            "Database" => "",
                            "DbMapper" => "",
                            "Criteria" => "",
                            "Translate" => "",
                            "Acl" => "",
                            "Cacher" => "");
                            
    public static function loadModel($class_name)
    {
        $file = Config::get("MODELS_PATH").self::classNameToFile($class_name); 
        return self::loadFile($file);    
    }
    
    public static function loadView($class_name)
    {
        $file = Config::get("VIEWS_PATH").self::classNameToFile($class_name); 
        return self::loadFile($file);    
    }
    
    public static function loadComponent($class_name)
    {
        $file = Config::get("COMPONENTS_PATH").self::classNameToFile($class_name); 
        return self::loadFile($file);
    }
    
    public static function loadController($class_name)
    {
        $file = Config::get("CONTROLLERS_PATH").self::classNameToFile($class_name); 
        return self::loadFile($file);
    }
    
    public static function loadCore($class_name)
    {
        $file = Config::get("CORE_PATH").self::classNameToFile($class_name);
        return self::loadFile($file);
    }
    
    public static function loadFile($file)
    {
        require_once($file);
        return true;
    }
    
    public static function classNameToFile($class_name)
    {
        return $class_name.".php";
    }
    
    public static function loadClass($class_name)
    {
        //echo "__AUTOLOAD__ ".$class_name."<br>";
        
        if(isset(self::$coreClasses[$class_name]))
        {
            return self::loadCore($class_name);
        }        
                                                          
        if(substr_compare($class_name, "Controller", -10) == 0)
        {
            return self::loadController($class_name);
        }
        
        if(substr_compare($class_name, "Model", -5) == 0) 
        {
            return self::loadModel($class_name); 
        }
        
        if(substr_compare($class_name, "Record", -6) == 0) 
        {
            $class_name = substr($class_name, 0, -6)."Model";
            return self::loadModel($class_name); 
        }
        
        if(substr_compare($class_name, "View", -4) == 0)
        {
            return self::loadView($class_name); 
        }
        
        return self::loadComponent($class_name);

    }
}

?>